﻿//WRITTEN BY GAMEPILL.COM
//SUPER CLASS for all MC's that have code behind and are owned by the GameController

import mx.events.EventDispatcher;

class GamePiece extends MovieClip{
	
	
	//************************************************************
	//PRIVATE VARS
	//************************************************************
	
	
	//Event Dispatching necessary vars 
	private var _dispatchersSetup:Boolean = false;
	private var dispatchEvent:Function;
	//private var dispatchQueue:Function;
	
	public var myPauseInterval:Object;
	
	//************************************************************
	//PROPERTIES
	//************************************************************
	
	
	

	//************************************************************
	//CONSTRUCTOR FUNCTIONS
	//************************************************************

	public function GamePiece(){
		
		trace("GamePiece Created");
		
		
	}
	
	
	
	//************************************************************
	//VISUAL FUNCTIONS
	//************************************************************
	
	
	public function hideGamePieceTween(){
		
		this.enabled = false;
		var callback = {scope: this, func: this.hideGamePiece, args:this};
		this.tween("_alpha",0,1,"customEasing", 0, callback);
		
	}
	
	public function hideTweenedGamePiece(args){
		
		trace("args[0] = " + args);
		trace(this);
		this.enabled = false;
		this._visible = false;
		
	}
	
	
	
	
	public function showGamePieceTween(){
		
		this.enabled = true;
		this._visible = true;
		this._alpha = 0;
		this.tween("_alpha",100,1,"customEasing");
		
	}
	
	//[nobfc]
	public function hideGamePiece(){
		
		this.enabled = false;
		this._visible = false;
		
	}
	
	public function showGamePiece(){
		
		this.enabled = true;
		this._visible = true;
		
	}
	
	/*public function showGamePieceWithZeroAlpha(){
		
		this.enabled = true
		this._visible = true;
		this._alpha = 0;
		
	}*/
	
	
	
	
	//************************************************************
	//INITIAL FUNCTIONS
	//************************************************************
	
	
	//************************************************************
	//PUBLIC GENERAL FUNCTIONS
	//************************************************************
	
	
	//************************************************************
	//PRIVATE GENERAL FUNCTIONS
	//************************************************************
	
	private function makeThisADispatcher(){
		
		if(!_dispatchersSetup){
				
				EventDispatcher.initialize(this);
				_dispatchersSetup = true;
				
			}
		
	}
	
	
	//constructs the dispatched event object with a target, type, and a message object to be read by the listener
	private function dispatchMyEvent(eventType:String, myMessageObject:Object){
		
		dispatchEvent({target:this, type:eventType, messageObject:myMessageObject});
		
	}
	
	
	
	
	
	//creates wwa pause and after calles the delegate function sent in
	private function pauseCodeAndCallFunction(pauseTime:Number, functionToCall:Function){
		
		myPauseInterval = setInterval(pauseIntervalFnc, pauseTime, {callingMC:this, funcToCall:functionToCall});
		
	}
	
	
	
	
	
	//nobfc
	private function pauseIntervalFnc(arg){
		
		arg.funcToCall(arg.callingMC);
		clearInterval(arg.callingMC.myPauseInterval);
		
	}
	

	
	
	
	//************************************************************
	//REGULAR EVENT FUNCTIONS
	//************************************************************
	
	
	
	//************************************************************
	//CUSTOM EVENT FUNCTIONS
	//************************************************************
	

	
	
	
	
	
	
	
	
}